using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.IO;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            BindData();
        }
    }

    private void BindData()
    {
        SqlConnection myConnection = new SqlConnection("Server=localhost;Database=School;Trusted_Connection=true");
        SqlDataAdapter ad = new SqlDataAdapter("SELECT * FROM Users", myConnection);
        DataSet ds = new DataSet();
        ad.Fill(ds);

        gvUsers.DataSource = ds;
        gvUsers.DataBind(); 
    }

    protected void Btn_ExportClick(object sender, EventArgs e)
    {
        string style = @"<style> .text { mso-number-format:\@; } </script> "; 

        Response.ClearContent();
        Response.AddHeader("content-disposition", "attachment; filename=MyExcelFile.xls");
        Response.ContentType = "application/excel";

        StringWriter sw = new StringWriter();
        HtmlTextWriter htw = new HtmlTextWriter(sw);

        gvUsers.RenderControl(htw);
        // Style is added dynamically
        Response.Write(style); 
        Response.Write(sw.ToString());
        Response.End();
    }

    protected void Btn_ExportExcelPaging(object sender, EventArgs e)
    {
        DisableControls(gvUsers);

        Response.ClearContent();
        Response.AddHeader("content-disposition", "attachment; filename=MyExcelFile.xls");
        Response.ContentType = "application/excel";

        StringWriter sw = new StringWriter();
        HtmlTextWriter htw = new HtmlTextWriter(sw);

        gvUsers.RenderControl(htw);
        Response.Write(sw.ToString());
        Response.End();       
    }

    private void DisableControls(Control gv)
    {
        LinkButton lb = new LinkButton();
        Literal l = new Literal(); 

        string name = String.Empty;

        for (int i = 0; i < gv.Controls.Count; i++)
        {
            if (gv.Controls[i].GetType() == typeof(LinkButton))
            {
                l.Text = (gv.Controls[i] as LinkButton).Text; 
                gv.Controls.Remove(gv.Controls[i]);
                gv.Controls.AddAt(i, l);
            }

            else if (gv.Controls[i].GetType() == typeof(DropDownList))
            {
                l.Text = (gv.Controls[i] as DropDownList).SelectedItem.Text;
                gv.Controls.Remove(gv.Controls[i]);
                gv.Controls.AddAt(i, l);
            }


            if (gv.Controls[i].HasControls())
            {
                DisableControls(gv.Controls[i]); 
            }
        }      

    }

    public override void VerifyRenderingInServerForm(Control control)
    {
        
    }

    protected void gvUsers_RowDataBound(object sender, GridViewRowEventArgs e)
    {      

        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            e.Row.Cells[1].Attributes.Add("class", "text"); 
        }
    }
}
